<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/02/2004 *
 * ===================                          Last change: 09/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : view.php                                         *
 * -------------------------------------------------------------------- *
 * Short description : View a banner and count his views                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Banner anzeigen und Views zaehlen                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Set module
$GLOBALS['__module'] = 'view';
$GLOBALS['output_mode'] = -1;

// Load the required file(s)
require('inc/config-global.php');

if ((isGetRequestElementSet('user')) && (isGetRequestElementSet('banner'))) {
	// For later things... ;-)
	$result = SQL_QUERY_ESC("SELECT `url` FROM `{?_MYSQL_PREFIX?}_refbanner` WHERE `id`=%s LIMIT 1",
		array(bigintval(getRequestElement('banner'))), __FILE__, __LINE__);

	// Do we have the banner?
	if (SQL_NUMROWS($result) == 1) {
		// Load the URL
		$data = SQL_FETCHARRAY($result);

		// Update counter
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_refbanner` SET `counter`=`counter`+1 WHERE `id`=%s LIMIT 1",
			array(bigintval(getRequestElement('banner'))), __FILE__, __LINE__);

		// Set header and ...
		setContentType('image/' . substr($data['url'], -3, 3));

		// Redirect
		redirectToUrl($data['url'], false);
	} else {
		// @TODO No banner found, output some default banner
		logDebugMessage(__FILE__, __LINE__, 'Banner ' . bigintval(getRequestElement('banner')) . ' not dound.');
	}

	// Free memory
	SQL_FREERESULT($result);
} else {
	// Do nothing for now
	redirectToUrl('modules.php?module=index');
}

// Shutdown
shutdown();

// [EOF]
?>
